#!/usr/bin/python

################################################## piRPred ###################################################
# V 1.0
# Brayet Jocelyn
# Ibisc / Genethon
# 04/2014
#
#
# piRPred : a machine learning method based on the fusion of multiple kernels and support vector machines (SVM). 
#
#
# Variables : 
#
# The path is the unzipped folder :
repertoire="/home/pbatista/Desktop/piRPred_webserver/"
# Number test sequences :
totalSeq=400
# Test 400 sequences (200 positives et 200 negatives). If unknown label, put nombrePositifsTest=totalSeq et nombreNegatifsTest=0
nombrePositifsTest=200
nombreNegatifsTest=200
# Nunber train sequences : 
numbreTrainSeq = 15001

################################################################################################################


import numpy as np
import scipy as sp
from scipy.spatial.distance import pdist, squareform
import matplotlib
import pylab as py
import os
import random
import decimal
import subprocess


def recupSeq(fichier):

	dicoSeq={}
	infosSeq=""
	idSeq=""
	
	fichierSeq=open(fichier,"r")

	for line in fichierSeq:
		
		if line.startswith(">"):

			idSeq=line[1:].replace("\n","")
		
		else:
			line=line.replace("T","U")
			dicoSeq[idSeq]=line.replace("\n","")

	return dicoSeq


def kmer(dicoSequences,fichierMatrice):

	fichierM=open(fichierMatrice,"a")
	
	tabKmer=["CGCG","CGUA","ACGCA","ACGCG","ACGUA","AUCGC","AUCGU","GGGCG","GCGAA","GCGAG","GCGAC","GCGCA","GCGCG","GCGUA","GUACG","CGACG","CGCAA","CGCAC","CGCAU","CGCGA","CGCGG","CGCGC","CGCGU","CGCUA","CGUAG","CGUAC", "CGUAU","CGUCG","CCGCG","UGCUG","UCGCG","UCGUA"]

	dicoKmer={}
	tailleSeq=0.0
	
	for idSeq in dicoSequences:
		tabResultsKmer=[]
		stringResult=""
		tailleSeq=len(dicoSequences[idSeq])

		if dicoSequences[idSeq].startswith('U'):

			tabResultsKmer.append(1)

		else:

			tabResultsKmer.append(0)

		nombre=0.0

		for kmer in tabKmer:

			nombre=dicoSequences[idSeq].count(kmer)

	
			nombre=float(nombre/(tailleSeq/float(len(kmer))))

			
			tabResultsKmer.append(nombre)


		dicoKmer[idSeq]=tabResultsKmer

		stringResult=str(tabResultsKmer)
		stringResult=stringResult.replace("[","")
		stringResult=stringResult.replace("]","")
		stringResult=stringResult.replace(", ","\t")
		fichierM.write(str(idSeq)+"\t"+stringResult+"\n")

	fichierM.close()
	return dicoKmer


def recupPosition(fichier):

	dicoPosition={}
	infosSeq1=""
	infosSeq2=""
	idSeq=""
	chro=""
	strand=""
	posStart=""
	posStop=""
	idChroStrand=""
	
	fichierPos=open(fichier,"r")

	for line in fichierPos:
		tabDico=[]

		if line.startswith(">"):

			infosSeq=line.split("|")
			idSeq=infosSeq[0]
			idSeq=idSeq[1:]

			infosSeq2=line.split(":")
			chro=infosSeq2[1]
			strand=infosSeq2[4].replace("\n","")
			posStart=infosSeq2[2]
			posStop=infosSeq2[3]

			#print(idSeq+" "+chro+" "+strand)

			idChroStrand=chro+"_"+strand

			if idChroStrand in dicoPosition:

				tabDico=dicoPosition[idChroStrand]
				tabDico.append(idSeq)
				tabDico.append(posStart)
				tabDico.append(posStop)

			else :

				tabDico.append(idSeq)
				tabDico.append(posStart)
				tabDico.append(posStop)
				dicoPosition[idChroStrand]=tabDico

	return dicoPosition


def matriceDistance(tabChroBrin):
	nbLignes=len(tabChroBrin)/3
	nbColonnes=len(tabChroBrin)/3
	
	tabPos=[]
	count=1

	for i in range(len(tabChroBrin)/3):
		tabPos.append(tabChroBrin[count])
		count=count+3

	matrice = []
	for i in tabPos:
		col = []
		for j in tabPos:
			col.append(valeurAbsolue(int(i)-int(j)))
		matrice.append(col)

	return matrice
			


def valeurAbsolue(val):
	if (val<0):
		return -val
	elif (val>0):
		return val
	else:
		return 0


def afficheMatrice(matrice,fichier):
	fichierMatrice=open(fichier,"w")
	
	for i in range(len(matrice)):
		afficheMatrice=""
		for j in range(len(matrice)):
			afficheMatrice=afficheMatrice+" "+str(matrice[i][j])
	
		fichierMatrice.write(afficheMatrice+"\n")

	return afficheMatrice

def chargeCentroTelo(fichier):

	fichierCentroTelo=open(fichier,"r")

	dicoCentroTelo={}
	tabInfos=[]
	
	for line in fichierCentroTelo:

		tabPosition=[]

		tabInfos=line.split("\t")

		#print tabInfos
		
		tabPosition.append(tabInfos[1])
		tabPosition.append(tabInfos[2])
		tabPosition.append(tabInfos[3])
		tabPosition.append(tabInfos[4].replace("\n",""))

		#print tabPosition
		
		dicoCentroTelo[tabInfos[0]]=tabPosition
	
	fichierCentroTelo.close()
	return dicoCentroTelo


def recupInfosPosition(fichier):

	dicoPos={}
	tabInfo=[]
	nombreID=0

	fichierPosition=open(fichier,"r")

	for line in fichierPosition:

		tabInfo=line.split(":")
		tabInfo[3]=tabInfo[3].replace("\n","")

		dicoPos[nombreID]=tabInfo
		
		nombreID=nombreID+1
	fichierPosition.close()
	return dicoPos


def creationFichiersMatriceTeloCentro(tabChro,repertoire):

	for i  in tabChro:

		fichier=open(repertoire+"matriceTemp_"+str(i)+".txt","w")
		fichier.close()

	return "creationFichiersMatriceTeloCentro DONE"


def caclTeloCentro(dicoTeloCentro,dicoPosOrNeg,tabChro,repertoire):

	chro=""

	for c in tabChro:

		fichier=open(repertoire+"matriceTemp_"+str(c)+".txt","a")

		info=[]
		posTeloCentro=[]
		chroBrin=""
		chro=c.replace("+","")
		chro=chro.replace("-","")
		posTeloCentro=dicoTeloCentro[chro]

		calcT1=""
		calcC1=""
		calcC2=""
		calcT2=""

		for iterateur in dicoPosOrNeg:

			info=dicoPosOrNeg[iterateur]

			chroBrin=info[1]+info[3]

			if c == chroBrin:

				if (int(info[2])<int(posTeloCentro[0])) or ((int(info[2])>int(posTeloCentro[1])) and (int(info[2])<int(posTeloCentro[2]))) or (int(info[2])>int(posTeloCentro[3])):

					calcT1="Inf"
					calcC1="Inf"
					calcC2="Inf"
					calcT2="Inf"

				else:

					calcT1=valeurAbsolue(int(info[2])-int(posTeloCentro[0]))
					calcC1=valeurAbsolue(int(info[2])-int(posTeloCentro[1]))
					calcC2=valeurAbsolue(int(info[2])-int(posTeloCentro[2]))
					calcT2=valeurAbsolue(int(info[2])-int(posTeloCentro[3]))
					
			else:

				calcT1="Inf"
				calcC1="Inf"
				calcC2="Inf"
				calcT2="Inf"	


			fichier.write(str(info[0])+"\t"+str(calcT1)+"\t"+str(calcC1)+"\t"+str(calcC2)+"\t"+str(calcT2)+"\n")
		
			
		fichier.close()

	return "caclTeloCentro DONE" 



def filesTeloCentro(repertoire):

	nomsFichiers = os.listdir(repertoire)

	for nomfile in nomsFichiers:

		if "Temp" in nomfile:

			fichier=open(repertoire+str(nomfile),"r")

			#newname=""
			newname=nomfile.replace("Temp","")

			tabInfo=""
			dicoResult={}

			#print nomfile

			for line in fichier:

				tabPosition=[]

				tabInfo=line.split("\t")
				#print tabInfo
				tabInfo[4]=tabInfo[4].replace("\n","")
				tabPosition.append(tabInfo[1])
				tabPosition.append(tabInfo[2])
				tabPosition.append(tabInfo[3])
				tabPosition.append(tabInfo[4])

				if tabInfo[0] in dicoResult:
	
					tabComparaison=dicoResult[tabInfo[0]]
	
					for i in range(len(tabComparaison)):
	
						if tabComparaison[i]=="Inf":
							tabComparaison[i]=tabInfo[i+1]
						elif not(tabInfo[i+1]=="Inf"):
							if int(tabComparaison[i])>int(tabInfo[i+1]):
								tabComparaison[i]=tabInfo[i+1]
	
					dicoResult[tabInfo[0]]=tabComparaison
	
				else:
	
					dicoResult[tabInfo[0]]=tabPosition
				


			fichier.close()

			fichierFinal=open(repertoire+str(newname),"w")

			dicoTrie=sorted(dicoResult,reverse=True)
			tabPos=[]
			for name in dicoTrie:

				tabPos=dicoResult[name]

				fichierFinal.write(str(name)+"\t"+str(tabPos[0])+"\t"+str(tabPos[1])+"\t"+str(tabPos[2])+"\t"+str(tabPos[3])+"\n")

			fichierFinal.close()


	for nomfile in nomsFichiers:

		if "Temp" in nomfile:
			os.remove(repertoire+str(nomfile))


	
	return "filesTeloCentro DONE" 



def creationFichierPosiiton(dicoSeq,fichierEntree,fichierSortie):

	
	fichier=open(fichierSortie,"w")

	tabInfo=""

	

	for name in dicoSeq:

		fichierPosition=open(fichierEntree,"r")

		for line in fichierPosition:

			tabInfo=line.split(":")

			if name==tabInfo[0]:

				fichier.write(line)

		fichierPosition.close()

	fichier.close()

	return "creationFichierPosiiton DONE"


def filesSVMLabel(nombrePositifsTrain,nombreNegatifsTrain,nombrePositifsTest,nombreNegatifsTest):

	fichierTrain=open(repertoire+"labelsTrain.txt","w")

	for i in range(nombrePositifsTrain):

		fichierTrain.write("1\n")

	for i in range(nombreNegatifsTrain):

		fichierTrain.write("-1\n")

	fichierTrain.close()

	fichierTest=open(repertoire+"labelsTest.txt","w")

	for i in range(nombrePositifsTest):

		fichierTest.write("1\n")

	for i in range(nombreNegatifsTest):

		fichierTest.write("-1\n")

	fichierTest.close()





nombrePositifsTrain=0
nombreNegatifsTrain=0



dicoSeqTest={}
dicoKmerTest={}
dicoPosTest={}
dicoPos={}

dicoPosCentroTelo={}
tabChro=["1+","2+","3+","4+","5+","6+","7+","8+","9+","10+","11+","12+","13+","14+","15+","16+","17+","18+","19+","20+","21+","22+","X+","Y+","1-","2-","3-","4-","5-","6-","7-","8-","9-","10-","11-","12-","13-","14-","15-","16-","17-","18-","19-","20-","21-","22-","X-","Y-"]

tabChroDroso=["2L+","2R+","3L+","3R+","4+","X+","2L-+","2R-","3L-","3R-","4-","X-"]


seuilDistance = 200000


def populationTest():

	dicoSeqTest=recupSeq(repertoire+"sequence_test.txt")

############################################# A Activer pour la sequence Test #################################

	fichierMatriceKmer=open(repertoire+"Test/matriceKmer_test_2.txt","w")
	fichierMatriceKmer.close()

	dicoKmeTest=kmer(dicoSeqTest,repertoire+"Test/matriceKmer_test_2.txt")


###########################################################################################################

############################################# A Activer pour la position #################################

	dicoPosCentroTelo=chargeCentroTelo(repertoire+"centroTeloPos.txt")

	dicoPosTest=recupInfosPosition(repertoire+"position_test.txt")

	print creationFichiersMatriceTeloCentro(tabChro,repertoire+"Test/matricesPosition/")

	print caclTeloCentro(dicoPosCentroTelo,dicoPosTest,tabChro,repertoire+"Test/matricesPosition/")

	print filesTeloCentro(repertoire+"Test/matricesPosition/")

###########################################################################################################


populationTest()



filesSVMLabel(nombrePositifsTrain,nombreNegatifsTrain,nombrePositifsTest,nombreNegatifsTest)



####################################################################




fichierReference=open(repertoire+"Test/matricesPosition/matrice_1-.txt","r")

tabID = []

for line in fichierReference:

	name=line.split("\t")
	tabID.append(name[0])


fichierReference.close()


fichierResult=open(repertoire+"Test/matriceKmer_test_2_ordre.txt","w")
fichierResult.close()

for val in tabID:
	fichierResult=open(repertoire+"Test/matriceKmer_test_2_ordre.txt","a")
	fichierKmer=open(repertoire+"Test/matriceKmer_test_2.txt","r")
	
	for line in fichierKmer:

		name=line.split("\t")
		line=line.replace("\n","")
		if val==name[0]:

			fichierResult.write(line+"\n")

	fichierKmer.close()

fichierResult.close()


##################################################




nomsFichiers = os.listdir(repertoire+"Test/matricesPosition/")



fichier = open(repertoire+"Test/matricesPosition/"+str(nomsFichiers[0]),"r")

dicoPos={}
tabInfo=[]
tabPos=[]

for line in fichier:
	
	line=line.replace("\n","")
	tabInfo=line.split("\t")

	#print tabInfo
	tabPos=tabInfo[1:5]
	#print tabPos
	dicoPos[tabInfo[0]]=tabPos


fichier.close()

#print dicoPos

for i in nomsFichiers:

	tabInfo=[]
	tabPos=[]
	tabPosDico=[]
	fichier=open(repertoire+"Test/matricesPosition/"+str(i),"r")
	
	for line in fichier:

		line=line.replace("\n","")
		tabInfo=line.split("\t")

		tabPos=tabInfo[1:5]

		tabPosDico=dicoPos[tabInfo[0]]

		for ite in range(len(tabPos)):
			if not(tabPos[ite]=="Inf")and(tabPosDico[ite]=="Inf"):
				tabPosDico[ite]=tabPos[ite]
			elif not(tabPosDico[ite]=="Inf")and(not(tabPos[ite]=="Inf")):
				if int(tabPos[ite])<int(tabPosDico[ite]):
					tabPosDico[ite]=tabPos[ite]
			

		
		dicoPos[tabInfo[0]]=tabPosDico


		
fichierResult=open(repertoire+"Test/pos_test_2.txt","w")

tabPosDico=[]

for val in dicoPos:

	
	tabPosDico=dicoPos[val]
	fichierResult.write(str(val)+"\t"+tabPosDico[0]+"\t"+tabPosDico[1]+"\t"+tabPosDico[2]+"\t"+tabPosDico[3]+"\n")


fichierResult.close()



############################################



fichierReference=open(repertoire+"Test/matricesPosition/matrice_1-.txt","r")

tabID = []

for line in fichierReference:

	name=line.split("\t")
	tabID.append(name[0])


fichierReference.close()


fichierResult=open(repertoire+"Test/pos_test_2_ordre.txt","w")
fichierResult.close()

for val in tabID:
	fichierResult=open(repertoire+"Test/pos_test_2_ordre.txt","a")
	fichierKmer=open(repertoire+"Test/pos_test_2.txt","r")
	
	for line in fichierKmer:

		name=line.split("\t")
		line=line.replace("\n","")
		if val==name[0]:

			fichierResult.write(line+"\n")

	fichierKmer.close()

fichierResult.close()




#######################################


def creationFichiersMatriceTeloCentro(tabChro,repertoire):

	for i  in tabChro:

		fichier=open(repertoire+"Test/kppv/matriceKplusprocheTemp_"+str(i)+".txt","w")
		fichier.close()

	return "creationFichiersMatriceKplusProches DONE"


def caclTeloCentro(tabChro,repertoire):

	chro=""
	strand=""

	for c in tabChro:

		fichier=open(repertoire+"Test/kppv/matriceKplusprocheTemp_"+str(c)+".txt","a")

		fichierMatriceTeloCentro=open(repertoire+"Test/matricesPosition/matrice_"+str(c)+".txt","r")

		info=[]
		info2=[]

		if "-" in c:

			strand = "-"

		else:

			strand = "+"

		chro=c.replace("+","")
		chro=chro.replace("-","")

		



		for line in fichierMatriceTeloCentro:

			info=line.split("\t")

			if not(info[1]=="Inf"):

				
				#print info[1]

				if "piR" in info[0]:

					fichierPosition=open(repertoire+"position_test.txt","r")

					for line2 in fichierPosition:

						#print "ICI"

						line2=line2.replace("\n","")
						info2=line2.split(":")
		
						if (info2[0]==info[0]) and (info2[1]==chro) and (info2[3]==strand):

							fichier.write(info2[0]+"\t"+info2[2]+"\n")



					fichierPosition.close()

				else:

					fichierPosition=open(repertoire+"position_test.txt","r")

					#print "ICI"
					for line2 in fichierPosition:
				
						line2=line2.replace("\n","")
						info2=line2.split(":")

					#	print info2
					#	print info2[0]
					#	print info[0]
					#	print info2[1]
					#	print c
	
		
						if (info2[0]==info[0]) and (info2[1]==chro) and (info2[3]==strand):

							fichier.write(info2[0]+"\t"+info2[2]+"\n")



					fichierPosition.close()


			else:

				fichier.write(info[0]+"\t"+info[4])


		fichierMatriceTeloCentro.close()
		fichier.close()


	return "caclTeloCentro DONE" 


def filesTeloCentro(repertoire):

	nomsFichiers = os.listdir(repertoire+"Test/kppv/")

	for nomfile in nomsFichiers:

		if "Temp" in nomfile:

			fichier=open(repertoire+"Test/kppv/"+str(nomfile),"r")

			#newname=""
			newname=nomfile.replace("Temp","")

			tabInfo=""
			dicoResult={}

			#print nomfile

			for line in fichier:

				tabPosition=[]
				line=line.replace("\n","")
				tabInfo=line.split("\t")
				tabPosition.append(tabInfo[1])

				if tabInfo[0] in dicoResult:
	
					tabComparaison=dicoResult[tabInfo[0]]
	
					for i in range(len(tabComparaison)):
	
						if tabComparaison[i]=="Inf":
							tabComparaison[i]=tabInfo[i+1]
						elif not(tabInfo[i+1]=="Inf"):
							if int(tabComparaison[i])>int(tabInfo[i+1]):
								tabComparaison[i]=tabInfo[i+1]
	
					dicoResult[tabInfo[0]]=tabComparaison
	
				else:
	
					dicoResult[tabInfo[0]]=tabPosition
				


			fichier.close()

			fichierFinal=open(repertoire+"Test/kppv/"+str(newname),"w")

			dicoTrie=sorted(dicoResult,reverse=True)
			tabPos=[]
			for name in dicoTrie:

				tabPos=dicoResult[name]

				fichierFinal.write(str(name)+"\t"+str(tabPos[0])+"\n")

			fichierFinal.close()


	for nomfile in nomsFichiers:

		if "Temp" in nomfile:
			os.remove(repertoire+"Test/kppv/"+str(nomfile))


	
	return "filesTeloCentro DONE" 



creationFichiersMatriceTeloCentro(tabChro,repertoire)

caclTeloCentro(tabChro,repertoire)

filesTeloCentro(repertoire)

##########################################################################

subprocess.call(["Rscript", repertoire+"scripts/codeNoyaux_kmer_test.R"])



fichier=open(repertoire+"matriceKmer_test_3.txt","r")
fichierResult=open(repertoire+"noyau_kmer_test_3.txt","w")

fichierResult.write(str(totalSeq)+" "+str(numbreTrainSeq)+" \n")

for line in fichier:

	fichierResult.write(line)


fichier.close()
fichierResult.close()

os.remove(repertoire+"matriceKmer_test_3.txt")

######################################################################


subprocess.call(["Rscript", repertoire+"scripts/codeNoyaux_position_test.R"])



fichier=open(repertoire+"pos_test_2.txt","r")
fichierResult=open(repertoire+"pos_test_3.txt","w")

fichierResult.write(str(totalSeq)+" "+str(numbreTrainSeq)+" \n")

for line in fichier:

	fichierResult.write(line)


fichier.close()
fichierResult.close()

os.remove(repertoire+"pos_test_2.txt")


########################################################################

subprocess.call(["Rscript", repertoire+"scripts/noyau_kplus_proche_test.R"])



fichier=open(repertoire+"noyau_kppv_test_2.txt","r")
fichierResult=open(repertoire+"noyau_kppv_test_3.txt","w")

fichierResult.write(str(totalSeq)+" "+str(numbreTrainSeq)+" \n")

for line in fichier:

	fichierResult.write(line)


fichier.close()
fichierResult.close()

os.remove(repertoire+"noyau_kppv_test_2.txt")


#############################################################################


#print "Premier"



tabmatrix=[]
fichier = open(repertoire+"noyau_kmer_test_3.txt","r")


count=0

for line in fichier:
	
	if (count>=1):	

		line=line.replace("\n","")
		tabInfo=line.split(" ")
		
		#tabInfo2=tabInfo[1:]
		tabmatrix.append(tabInfo)
	count=count+1

	

fichier.close()


X=np.array(tabmatrix,float)



tabmatrix=[]
fichier = open(repertoire+"pos_test_3.txt","r")


count=0

for line in fichier:
	
	if (count>=1):	

		line=line.replace("\n","")
		tabInfo=line.split(" ")
		
		#tabInfo2=tabInfo[1:]
		tabmatrix.append(tabInfo)
	count=count+1

	

fichier.close()


X=X +np.array(tabmatrix,float)


tabmatrix=[]
fichier = open(repertoire+"noyau_kppv_test_3.txt","r")


count=0

for line in fichier:
	
	if (count>=1):	

		line=line.replace("\n","")
		tabInfo=line.split(" ")
		
		#tabInfo2=tabInfo[1:]
		tabmatrix.append(tabInfo)
	count=count+1

	

fichier.close()


X=(X+np.array(tabmatrix,float))/3


np.savetxt(repertoire+"noyau_moyenne_tmp.txt", X,delimiter="\t")



fichierResult=open(repertoire+"noyau_moyenne_kppv_kmer_pos_2","w")	

fichierResult.write(str(totalSeq)+" "+str(numbreTrainSeq)+" \n")
fichierResult.close()

fichier=open(repertoire+"noyau_moyenne_tmp.txt","r")

fichierResult=open(repertoire+"noyau_moyenne_kppv_kmer_pos_2","a")


for line in fichier:
	fichierResult.write(line)


fichier.close()
fichierResult.close()

os.remove(repertoire+"noyau_moyenne_tmp.txt")
os.remove(repertoire+"noyau_kppv_test_3.txt")
os.remove(repertoire+"noyau_kmer_test_3.txt")
os.remove(repertoire+"pos_test_3.txt")





############################################ END ######################################################













