################################################## piRPred scriptR ###################################################
# V 1.0
# Brayet Jocelyn
# Ibisc / Genethon
# 04/2014
#
#
# Building k-nearest neighbors kernel
#

# Variables :
# The path is the unzipped folder
setwd("//home//pbatista//Desktop//piRPred_webserver")

# Number neighbors :
nombreVoisins=4

# Nunber train sequences : 
numberSeqTrain=15001

# Test 400 sequences (200 positives et 200 negatives). If unknown label, put nombrePositifsTest=totalSeq et nombreNegatifsTest=0
numberSeqTestPos=200
numberSeqTestNeg=200



library("FNN")
library("fields")


nombreSeq=numberSeqTestPos+numberSeqTestNeg+numberSeqTrain



repertoireTest<-"./Test/kppv/"
repertoire<-"./Train/kppv/"





nomfilePosition=list.files(path = repertoire)
nomfilePositionTest=list.files(path = repertoireTest)



print("Kppv kernel")

vectNormFrobenius=c(rep(Inf,nombreSeq))

for(i in 1:nombreSeq){

	if (i==1){

		listMatrix=list(0)

	}else{

		listMatrix=c(listMatrix,list(0))
		
	}

}




for (k in 1:length(nomfilePosition)){

	print(nomfilePosition[k])

	data<-read.table(paste(repertoire,nomfilePosition[k],sep =""),row.names=1)

	datatest<-read.table(paste(repertoireTest,nomfilePositionTest[k],sep =""),row.names=1)

	data <- rbind(data,datatest)

	n<-nrow(data)
	m<-ncol(data)

	X<-as.matrix(data, nrow = n, ncol = m)

	X[X==Inf]<--3e+9

	indexKplusproche<-knn.index(X, k=4)

	for(i in 1:n){

		#print(i)

		positionKplusproche<-c(X[i,],X[indexKplusproche[i,],])

		positionKplusproche[positionKplusproche==-3e+9]<-Inf

		distanceKplusproche<-dist(positionKplusproche,method = "euclidean", diag = TRUE, upper = TRUE)

		distanceKplusproche[is.na(distanceKplusproche)]<-Inf

		normFrobenius<-norm(distanceKplusproche, type="F")

		if(is.nan(normFrobenius)){
			normFrobenius=Inf
		}

		if(vectNormFrobenius[i]==Inf){
			vectNormFrobenius[i]=normFrobenius
			listMatrix[[i]]=distanceKplusproche
		}

		if(vectNormFrobenius[i]>normFrobenius){
			vectNormFrobenius[i]=normFrobenius
			listMatrix[[i]]=distanceKplusproche
		}
	}
}


X<-matrix(0, nrow = (numberSeqTestPos+numberSeqTestNeg), ncol = numberSeqTrain)
count=1

for(i in 1:(numberSeqTestPos+numberSeqTestNeg)){

	for(j in count:numberSeqTrain){

		#print(i)
		#print(j)

		distance=norm(listMatrix[[i+numberSeqTrain]]-listMatrix[[j]], type="F")
		X[i,j]=distance
		#X[j,i]=distance


	}
	#count=count+1
}


X[is.na(X)]<-Inf

#distanceMatrix[is.infinite(distanceMatrix)]<-0

#distanceMatrix[is.infinite(distanceMatrix)]<-0

diag(X)<-0


#print(mean(X^2))
#print(median(X^2))

arg=-log(0.5)/median(X^2)

#print("Argument : ")
#print(arg)



distance=0



for(i in 1:50){

#	print("Argument : ")
#	print(arg)
	
	K <- exp(-(arg*(X^2)))

	valPositif<-mean(K[1:numberSeqTestPos,1:numberSeqTrain])/2
	valNegatif<-mean(K[(numberSeqTestPos+1):(numberSeqTestPos+numberSeqTestNeg),1:numberSeqTrain])/2

	distanceInterCluster<-dist(c(valPositif,valNegatif),method = "euclidean")

#	print("Distance : ")
#	print(distanceInterCluster)

	
	arg=arg+(arg/10)
	

	if (distance<distanceInterCluster){
		distance=distanceInterCluster
	}
	else{
		break
	}

}


write.table(K,file ="./noyau_kppv_test_2.txt", sep = " ", quote = FALSE,row.names = FALSE,col.names=FALSE)


print("Kppv kernel do")











